x axis log scale.
[dygraphs.git] / release.sh
CommitLineData
806e1ea5
DV
1#!/bin/bash
2# This script "releases" a version of dygraphs.
3
4if [ $# -ne 1 ]; then
5 echo "Usage: $0 X.Y.Z" >&2
6 exit 1
7fi
8
9VERSION=$1
10echo $VERSION | egrep '\d+\.\d+\.\d+' > /dev/null
11if [ $? -ne 0 ]; then
12 echo "Version must be of the form 1.2.3 (got '$VERSION')" >&2
13 exit 1
14fi
15
16# Make sure this is being run from a release branch with the correct name.
17branch=$(git rev-parse --abbrev-ref HEAD)
18if [ $branch != "release-$VERSION" ]; then
19 echo "Must be on a branch named 'release-$VERSION' (found '$branch')" >&2
20 exit 1
21fi
22
7655a77a
DV
23git status | grep 'working directory clean' > /dev/null
24if [ $? -ne 0 ]; then
25 echo "Must release with a clean working directory. Commit your changes." >&2
26 exit 1
27fi
28
29make lint test test-combined
30if [ $? -ne 0 ]; then
31 echo "Tests failed. Won't release!" >&2
32 exit 1
33fi
34
806e1ea5
DV
35# Push a permanent copy of documentation & generated files to a versioned copy
36# of the site. This is where the downloadable files are generated.
37# TODO(danvk): make sure this actually generates the downloadable files!
38echo "Pushing docs and generated files to dygraphs.com/$VERSION"
39./push-to-web.sh dygraphs.com:dygraphs.com/$VERSION
40if [ $? -ne 0 ]; then
41 echo "Push to web failed" >&2
42 exit 1
43fi
44
172be781
DV
45# Everything is good.
46# Switch to the "releases" branch, merge this change and tag it.
47echo "Switching branches to do the release."
48git checkout releases
49git merge --no-ff $branch
50
806e1ea5
DV
51COMMIT=$(git rev-parse HEAD)
52echo "Tagging commit $COMMIT as version $VERSION"
7655a77a 53git tag -a "v$VERSION" -m "Release of version $VERSION"
06682812 54git push --tags
806e1ea5
DV
55
56echo "Release was successful!"
9023a6d6
DV
57echo "Pushing the new version to dygraphs.com..."
58./push-to-web.sh dygraphs.com:dygraphs.com
59
60echo "Success!\n"
61echo "Don't forget to merge changes on this branch back into master:"
00179556 62echo "git merge --no-ff $branch"
172be781
DV
63
64# Discourage users from working on the "releases" branch.
65git checkout master